//****************************************************************************
//	aisa31s.pas
//
//	aISA-P31
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa31s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa31w;

const
	szTitle = 'Sample';
	szP31	 = 'aISA-P31';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer, dwDrvVer: DWord;
	bResult:	Boolean;				// 
	wLogSlot: Word;						// foCXi[
	InValue:	Byte;
	OutValue:	Byte;
	ri:				TAISA31RESOURCE;// \[X
begin
//---------------------------------------------------------------------------
	// aisa31.dll ̎gp錾
	if Aisa31wDllOpen() = False then
	begin
		ErrorMessage(AISA31_SLOT_AUTO);
		Exit;			// aisa31.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-P31 DLL,Driver̃o[Wԍ擾
	if Aisa31wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA31_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P31̎gp錾
	wLogSlot := AISA31_SLOT_AUTO;				// gp̃foCXT܂B

	bResult := Aisa31wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA31_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-P31 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa31wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'NumPorts: %2d'#10 +
									 'IO Address: %04xH-%04xH',
										 [szP31, ri.dwIOPortLength[1],
											ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// Port 1 ɔCӂ̃f[^o
	// o̓f[^ AAh
	OutValue := Byte($AA);

	if Aisa31wOutPort(wLogSlot, AISA31_PORT_1, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Port 1 փf[^o'#10 +
									 'Port 1 Out Data: %02xH',
									 [OutValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// Port 1 f[^ǂݍ
	InValue := Byte($00);

	if Aisa31wInPort(wLogSlot, AISA31_PORT_1, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Port 1 f[^'#10 +
									 'Port 1 In Data: %02xH',
									 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P31̎gpJ
	if Aisa31wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-P31 Closed');

	// aisa31.dll ̎gpJ
	if Aisa31wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa31.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa31wGetLastError(wLogSlot);

	case dwRes of
		AISA31_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA31_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-P31 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
