//****************************************************************************
//	aisa31w.pas
//
//	aISA-P31
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//****************************************************************************

unit aisa31w;

interface

uses
	Windows;

{ Errors }

const
	AISA31_SUCCESS				      = 0;	 { ُȂ }
	AISA31_ERR_SYSTEM			      = 1;	 { GetLastError sĂ }
	AISA31_ERR_NO_DEVICE		    = 2;	 { gp\ȃfoCXȂ }
	AISA31_ERR_IN_USE			      = 3;	 { w肳ꂽۯĂ͎gp }
	AISA31_ERR_INVALID_SLOT		  = 4;   { ȁi_jۯĔԍ }
	AISA31_ERR_RESOURCE			    = 5;	 { \[XG[ }
	AISA31_ERR_INVALID_PORT     = 6;	 { ȃ|[gԍ }
	AISA31_ERR_INVALID_ARGUMENT = 7;	 { Ȉ }

{ Port numbers }

const
	AISA31_PORT_1 =	0;
	AISA31_PORT_2 = 1;
	AISA31_PORT_3 = 2;
	AISA31_PORT_4 = 3;

{ Miscellaneous }

const
	AISA31_MAX_SLOTS	= 16;	{ Maximum number of slots }


{ Device ID }

const
	AISA31_DEVICE_ID	= $00005031;


const
	AISA31_MAX_PORT = 4;	{ aISA-P31̃|[g }

const
	AISA31_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA31_DLL_NAME = 'aisa31.dll';		{ DLL }

function Aisa31wDllOpen: Boolean;		{ DLL [h }
function Aisa31wDllClose: Boolean;	{ DLL A[h }


const
	AISA31_SLOT_AUTO = $ffff;

{ aISA-P31 DLL,Driver̃o[Wԍ擾 }
function Aisa31wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P31̎gp錾 }
function Aisa31wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P31̎gpJ }
function Aisa31wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA31_MAX_MEM	=	 9;
		AISA31_MAX_IO		= 20;
		AISA31_MAX_IRQ	=	 7;
		AISA31_MAX_DMA	=	 7;

type
		TAISA31RESOURCE = record
				dwNumMemWindows:DWord;																	{ س޳				gp }
				dwMemBase:			array [1 .. AISA31_MAX_MEM] of DWord;		{ س޳ްڽgp }
				dwMemLength:		array [1 .. AISA31_MAX_MEM] of DWord;		{ س޳				gp }
				dwMemAttrib:		array [1 .. AISA31_MAX_MEM] of DWord;		{ س޳			gp }
				dwNumIOPorts:		DWord;																	{ I/O߰Đ }
				dwIOPortBase:		array [1 .. AISA31_MAX_IO] of DWord;		{ I/O߰ްڽ }
				dwIOPortLength: array [1 .. AISA31_MAX_IO] of DWord;		{ I/O߰Ē }
				dwNumIRQs:			DWord;																	{ IRQ							gp }
				dwIRQRegisters: array [1 .. AISA31_MAX_IRQ] of DWord;		{ IRQؽ						gp }
				dwIRQAttrib:		array [1 .. AISA31_MAX_IRQ] of DWord;		{ IRQؽ				gp }
				dwNumDMAs:			DWord;																	{ DMAِ					gp }
				dwDMALst:				array [1 .. AISA31_MAX_DMA] of DWord;		{ DMAؽ				gp }
				dwDMAAttrib:		array [1 .. AISA31_MAX_DMA] of DWord;		{ DMAّؽ		gp }
				dwReserved1:		array [1 .. 3] of DWord;								{ \							gp }
		end;

PAISA31RESOURCE = ^TAISA31RESOURCE;


{ \[X擾 }
function Aisa31wGetResource(wLogSlot: Word; pResInfo: PAISA31RESOURCE): Boolean;


{ Cӂ̃|[gf[^ }
function Aisa31wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa31wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;


{ aISA-P31̃G[R[h }
function Aisa31wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa31GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa31Create = function(var pwLogSlot: Word): Bool; stdcall;
	TAisa31Close = function(wLogSlot:	Word): Bool; stdcall;
	TAisa31GetResource = function(wLogSlot: Word; pres: PAISA31RESOURCE): Bool; stdcall;
	TAisa31InPort = function(wLogSlot: Word; dwLogPort: DWord; var pbInValue: Byte): Bool; stdcall;
	TAisa31OutPort = function(wLogSlot: Word; dwLogPort: DWord; bOutValue: Byte): Bool; stdcall;
	TAisa31GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa31wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa31GetVersion: TAisa31GetVersion;
	pAisa31Create: TAisa31Create;
	pAisa31Close: TAisa31Close;
	pAisa31GetResource: TAisa31GetResource;
	pAisa31InPort: TAisa31InPort;
	pAisa31OutPort: TAisa31OutPort;
	pAisa31GetLastError: TAisa31GetLastError;


//****************************************************************************
// 		aisa31.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA31_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa31wGetDllExportFunc = False then
  begin
		Aisa31wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa31.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aISA-P31 DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drvo[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa31GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-P31̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wCreate(var pwLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa31Create(pwLogSlot);
end;

//****************************************************************************
// 		aISA-P31̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa31Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pResInfo \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wGetResource(wLogSlot: Word; pResInfo: PAISA31RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa31GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// 		Cӂ̃|[gf[^
// 		wLogSlot	͂foCX
//				dwPort		͂|[g
//				pbInValue ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa31InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// 		Cӂ̃|[gփf[^o
// 		wLogSlot	o͂foCX
//				dwPort		o͂|[g
//				bOutValue o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa31wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa31OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// 		aISA-P31̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa31wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA31_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa31GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 	  DLLGNX|[g֐AhX̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Aisa31wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa31GetVersion ̃AhX擾
	pAisa31GetVersion := GetProcAddress(hDLL, 'Aisa31GetVersion');
	if @pAisa31GetVersion = nil then Exit;

	// Aisa31Create ̃AhX擾
	pAisa31Create := GetProcAddress(hDLL, 'Aisa31Create');
	if @pAisa31Create = nil then Exit;

	// Aisa31Close ̃AhX擾
	pAisa31Close := GetProcAddress(hDLL, 'Aisa31Close');
	if @pAisa31Close = nil then Exit;

	// Aisa31GetResource ̃AhX擾
	pAisa31GetResource := GetProcAddress(hDLL, 'Aisa31GetResource');
	if @pAisa31GetResource = nil then Exit;

	// Aisa31InPort ̃AhX擾
	pAisa31InPort := GetProcAddress(hDLL, 'Aisa31InPort');
	if @pAisa31InPort = nil then Exit;

	// Aisa31OutPort ̃AhX擾
	pAisa31OutPort := GetProcAddress(hDLL, 'Aisa31OutPort');
	if @pAisa31OutPort = nil then Exit;

	// Aisa31GetLastError ̃AhX擾
	pAisa31GetLastError := GetProcAddress(hDLL, 'Aisa31GetLastError');
	if @pAisa31GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

