Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa31w.bas                                                               *
'*                                                                           *
'* aISA-P31                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/03/11                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA31_DLL_NAME = "aisa31.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA31_MAX_PORT = 4      ' aISA-P31̃|[g

Global Const AISA31_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa31.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wDllOpen() As Boolean

    Aisa31wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA31_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Aisa31wGetDllExportFunc() = False Then
        Aisa31wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa31wDllOpen = True

End Function

'*****************************************************************************
'*    aisa31.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wDllClose() As Boolean

    Aisa31wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa31wDllClose = False

End Function

'*****************************************************************************
'*    aISA-P31 DLL,Driver̃o[Wԍ擾                           *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean

    Aisa31wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa31GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
        
    Aisa31wGetVersion = True

End Function

'*****************************************************************************
'*    aISA-P31̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSlot  gpfoCXi[                                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wCreate(pwLogSlot As Integer) As Boolean

    Aisa31wCreate = False
    
    If hDLL = 0 Then Exit Function

    If Aisa31Create(pwLogSlot) = 0 Then Exit Function
        
    Aisa31wCreate = True

End Function

'*****************************************************************************
'*    aISA-P31̔Cӂ̃foCX̎gpJ                               *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wClose(wLogSlot As Integer) As Boolean

    Aisa31wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa31Close(wLogSlot) = 0 Then Exit Function
    
    Aisa31wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pResInfo \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wGetResource(wLogSlot As Integer, pResInfo As AISA31RESOURCE) As Boolean

    Aisa31wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Aisa31GetResource(wLogSlot, pResInfo) = 0 Then Exit Function
    
    Aisa31wGetResource = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot  ͂foCX                                         *
'*        dwPort    ͂|[g                                           *
'*        pbInValue ̓f[^i[                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean

    Aisa31wInPort = False

    If hDLL = 0 Then Exit Function

    If Aisa31InPort(wLogSlot, dwPort, pbInValue) = 0 Then Exit Function
    
    Aisa31wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot  o͂foCX                                         *
'*        dwPort    o͂|[g                                           *
'*        bOutValue o͂f[^                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa31wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean

    Aisa31wOutPort = False

    If hDLL = 0 Then Exit Function

    If Aisa31OutPort(wLogSlot, dwPort, bOutValue) = 0 Then Exit Function
    
    Aisa31wOutPort = True

End Function

'*****************************************************************************
'*    aISA-P31̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa31wGetLastError(wLogSlot As Integer) As Long

    Aisa31wGetLastError = AISA31_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Aisa31wGetLastError = Aisa31GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa31wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Aisa31wGetDllExportFunc = False
    
    ' Aisa31GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa31Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31Create")
    If pFunc = 0 Then Exit Function

    ' Aisa31Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31Close")
    If pFunc = 0 Then Exit Function

    ' Aisa31GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa31InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa31OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa31GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa31GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa31wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
