/*	aisa31.h

	AISA-P31 Win32 API.
*/

#ifndef _AISA31_H_
#define _AISA31_H_

#ifdef __cplusplus
extern "C" {
#endif


/* Errors */

#define AISA31_SUCCESS				0	// ُȂ
#define AISA31_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA31_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA31_ERR_IN_USE			3	// w肳ꂽۯĂ͎gp
#define AISA31_ERR_INVALID_SLOT		4	// ȁi_jۯĔԍ
#define AISA31_ERR_RESOURCE			5	// \[XG[
#define AISA31_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA31_ERR_INVALID_ARGUMENT	7	// Ȉ

/* Port numbers */

#define	AISA31_PORT_1	0
#define	AISA31_PORT_2	1
#define	AISA31_PORT_3	2
#define	AISA31_PORT_4	3

/* Miscellaneous */

#define	AISA31_MAX_SLOTS	16			/* Maximum number of slots */

#define	AISA31_SLOT_AUTO	((WORD) ~0U)

/* Device ID */

#define	AISA31_DEVICE_ID	(0x31UL | ('P' << 8) | (0x0000UL << 16))

/* Resource infomation structure */

#define AISA31_MAX_MEM		9
#define AISA31_MAX_IO		20
#define AISA31_MAX_IRQ		7
#define AISA31_MAX_DMA		7

typedef struct _AISA31RESOURCE
{
	DWORD	dwNumMemWindows;				   // س޳		gp
	DWORD	dwMemBase		[AISA31_MAX_MEM];  // س޳ްڽgp
	DWORD	dwMemLength		[AISA31_MAX_MEM];  // س޳		gp
	DWORD	dwMemAttrib		[AISA31_MAX_MEM];  // س޳		gp
	DWORD	dwNumIOPorts;					   // I/O߰Đ
	DWORD	dwIOPortBase	[AISA31_MAX_IO];   // I/O߰ްڽ
	DWORD	dwIOPortLength	[AISA31_MAX_IO];   // I/O߰Ē
	DWORD	dwNumIRQs;						   // IRQ				gp
	DWORD	dwIRQRegisters	[AISA31_MAX_IRQ];  // IRQؽ			gp
	DWORD	dwIRQAttrib		[AISA31_MAX_IRQ];  // IRQؽ		gp
	DWORD	dwNumDMAs;						   // DMAِ			gp
	DWORD	dwDMALst		[AISA31_MAX_DMA];  // DMAؽ		gp
	DWORD	dwDMAAttrib		[AISA31_MAX_DMA];  // DMAّؽ	gp
	DWORD	dwReserved1		[3];			   // \				gp
} AISA31RESOURCE;

typedef	AISA31RESOURCE		*	PAISA31R;
typedef	AISA31RESOURCE	FAR	*	LPAISA31R;


#ifndef	AISA31_API
#define	AISA31_API	1

#ifndef	AISA31_DS
#define	AISA31_DS	__declspec(dllimport)
#endif

AISA31_DS
BOOL	WINAPI Aisa31GetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer);
AISA31_DS
BOOL	WINAPI Aisa31Create(PWORD pwLogSlot);
AISA31_DS
BOOL	WINAPI Aisa31Close(WORD wLogSlot);
AISA31_DS
BOOL	WINAPI Aisa31GetResource(WORD wLogSlot, PAISA31R pRes);
AISA31_DS
BOOL	WINAPI Aisa31InPort(WORD wLogSlot, DWORD dwPort, PBYTE pbValue);
AISA31_DS
BOOL	WINAPI Aisa31OutPort(WORD wLogSlot, DWORD dwPort, BYTE bValue);
AISA31_DS
DWORD	WINAPI Aisa31GetLastError(WORD wLogSlot);

#endif	/* #ifndef	AISA31_API */

#ifdef __cplusplus
}
#endif

#endif	/* #ifndef	AISA31_H */
